      PROGRAM ORG__MAIN___
      INCLUDE 'mpif.h'
      EXTERNAL ORG___MAIN___
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTEGER(KIND=4):: ierrX0
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      CALL mpi_init(ierrX0)
      CALL mpi_comm_rank(MPI_COMM_WORLD,ORG_RANK,ierrX0)
      CALL mpi_comm_size(MPI_COMM_WORLD,ORG_SIZE,ierrX0)
      CALL ORG___MAIN___()
      CALL mpi_finalize(ierrX0)
      END PROGRAM
      SUBROUTINE ORG___MAIN___()
      INCLUDE 'mpif.h'
      REAL(KIND=4):: a(1:257,1:129,0:32,1:4)
      INTEGER(KIND=4):: npe
      PARAMETER (npe=4)
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      REAL(KIND=4):: ttarget
      PARAMETER (ttarget=60.0e0)
      REAL(KIND=4):: p(1:257,1:129,-1:33)
      REAL(KIND=4):: b(1:257,1:129,0:32,1:3)
      REAL(KIND=4):: c(1:257,1:129,0:32,1:3)
      REAL(KIND=4):: bnd(1:257,1:129,0:32)
      REAL(KIND=4):: wrk1(1:257,1:129,0:32)
      REAL(KIND=4):: wrk2(1:257,1:129,0:32)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      REAL(KIND=4):: time0(1:2)
      REAL(KIND=4):: time1(1:2)
      EXTERNAL initmt
      INTEGER(KIND=4):: nn
      REAL(KIND=4):: cpu0
      EXTERNAL gdtime
      REAL(KIND=4):: gdtime
      EXTERNAL jacobi
      REAL(KIND=4):: gosa
      REAL(KIND=4):: cpu1
      REAL(KIND=4):: cpu
      REAL(KIND=4):: flop
      INTRINSIC real
      REAL(KIND=4):: xmflops2
      INTRINSIC ifix
      REAL(KIND=4):: score
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTEGER(KIND=4):: ierrX0
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /workX1/wrk2
      COMMON /workX0/wrk1
      COMMON /boundX0/bnd
      COMMON /mtrxX2/c
      COMMON /mtrxX1/b
      COMMON /mtrxX0/a
      COMMON /presX0/p
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      omega = 0.8e0
      imax = 256
      jmax = 128
      kmax = 128
      CALL initmt()
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' mimax=',257,' mjmax=',1&
     &29,' mkmax=',129
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' imax=',imax,' jmax=',jm&
     &ax,' kmax=',kmax
      nn = 3
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Start rehearsal measure&
     &ment process.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Measure the performance&
     & in 3 times.'
      cpu0 = gdtime(time0)
      CALL jacobi(nn,gosa)
      cpu1 = gdtime(time1)
      cpu = cpu1
      flop = (real(kmax-2))*(real(jmax-2))*(real(imax-2))*(34.0e0)*(real&
     &(nn))
      xmflops2 = flop/cpu*(1.0E-6)
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) '  MFLOPS:',xmflops2,'  t&
     &ime(s):',cpu,gosa
      nn = ifix(ttarget/(cpu/(3.0e0)))
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'Now, start the actual me&
     &asurement process.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'The loop will be excuted&
     & in',nn,' times.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'This will take about one&
     & minute.'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) 'Wait for a while.'
      cpu0 = gdtime(time0)
      CALL jacobi(nn,gosa)
      cpu1 = gdtime(time1)
      cpu = cpu1
      flop = (real(kmax-2))*(real(jmax-2))*(real(imax-2))*(34.0e0)*(real&
     &(nn))
      xmflops2 = flop*(1.0E-6)/cpu
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Loop executed for ',nn,&
     &' times'
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Gosa :',gosa
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' MFLOPS:',xmflops2,'  ti&
     &me(s):',cpu
      score = xmflops2/(82.84e0)
      IF (ORG_RANK.EQ.0) WRITE (UNIT=*, FMT=*) ' Score based on Pentium &
     &III 600MHz :',score
      RETURN
      END SUBROUTINE
      SUBROUTINE initmt()
      INCLUDE 'mpif.h'
      REAL(KIND=4):: a(1:257,1:129,0:32,1:4)
      INTEGER(KIND=4):: npe
      PARAMETER (npe=4)
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      REAL(KIND=4):: ttarget
      PARAMETER (ttarget=60.0e0)
      REAL(KIND=4):: p(1:257,1:129,-1:33)
      REAL(KIND=4):: b(1:257,1:129,0:32,1:3)
      REAL(KIND=4):: c(1:257,1:129,0:32,1:3)
      REAL(KIND=4):: bnd(1:257,1:129,0:32)
      REAL(KIND=4):: wrk1(1:257,1:129,0:32)
      REAL(KIND=4):: wrk2(1:257,1:129,0:32)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      INTEGER(KIND=4):: j
      INTEGER(KIND=4):: i
      INTEGER(KIND=4):: k
      INTRINSIC float
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTRINSIC mod
      INTEGER(KIND=4):: spmdX0
      INTEGER(KIND=4):: spmdX1
      INTEGER(KIND=4):: spmd_startX0
      INTEGER(KIND=4):: spmd_endX0
      INTEGER(KIND=4):: spmd_stepX0
      INTEGER(KIND=4):: spmdX2
      INTEGER(KIND=4):: spmdX3
      INTEGER(KIND=4):: spmd_startX1
      INTEGER(KIND=4):: spmd_endX1
      INTEGER(KIND=4):: spmd_stepX1
      INTEGER(KIND=4):: ierrX0
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /workX1/wrk2
      COMMON /workX0/wrk1
      COMMON /boundX0/bnd
      COMMON /mtrxX2/c
      COMMON /mtrxX1/b
      COMMON /mtrxX0/a
      COMMON /presX0/p
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      spmdX0 = mod(ORG_RANK,4)
      spmdX1 = 33*spmdX0
      IF (spmdX0.LE.0) THEN
        spmd_startX0 = -spmdX1
      ELSE
        spmd_startX0 = 0
      ENDIF
      IF (spmdX0.LT.3) THEN
        spmd_endX0 = 32
      ELSE
        spmd_endX0 = 128-spmdX1
      ENDIF
      spmd_stepX0 = 1
      DO k=spmd_startX0,spmd_endX0,1
        DO j=1,129,1
          DO i=1,257,1
            a(i,j,k,1) = 0.0e0
            a(i,j,k,2) = 0.0e0
            a(i,j,k,3) = 0.0e0
            a(i,j,k,4) = 0.0e0
            b(i,j,k,1) = 0.0e0
            b(i,j,k,2) = 0.0e0
            b(i,j,k,3) = 0.0e0
            c(i,j,k,1) = 0.0e0
            c(i,j,k,2) = 0.0e0
            c(i,j,k,3) = 0.0e0
            p(i,j,k) = 0.0e0
            wrk1(i,j,k) = 0.0e0
            bnd(i,j,k) = 0.0e0
          ENDDO
        ENDDO
      ENDDO
      spmdX2 = mod(ORG_RANK,4)
      spmdX3 = 33*spmdX2
      IF (spmdX2.LE.0) THEN
        spmd_startX1 = -spmdX3
      ELSE
        spmd_startX1 = 0
      ENDIF
      IF (spmdX2.LT.(kmax-1)/33) THEN
        spmd_endX1 = 32
      ELSE
        spmd_endX1 = kmax-1-spmdX3
      ENDIF
      spmd_stepX1 = 1
      DO k=spmd_startX1,spmd_endX1,1
        DO j=1,jmax,1
          DO i=1,imax,1
            a(i,j,k,1) = 1.0e0
            a(i,j,k,2) = 1.0e0
            a(i,j,k,3) = 1.0e0
            a(i,j,k,4) = (1.0e0)/(6.0e0)
            b(i,j,k,1) = 0.0e0
            b(i,j,k,2) = 0.0e0
            b(i,j,k,3) = 0.0e0
            c(i,j,k,1) = 1.0e0
            c(i,j,k,2) = 1.0e0
            c(i,j,k,3) = 1.0e0
            p(i,j,k) = (float(k*k+2*spmdX3*k+spmdX3*spmdX3))/(float(kmax&
     &*kmax-2*kmax+1))
            wrk1(i,j,k) = 0.0e0
            bnd(i,j,k) = 1.0e0
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END SUBROUTINE
      SUBROUTINE jacobi(nn,gosa)
      INCLUDE 'mpif.h'
      INTEGER(KIND=4):: nn
      REAL(KIND=4):: gosa
      REAL(KIND=4):: a(1:257,1:129,0:32,1:4)
      INTEGER(KIND=4):: npe
      PARAMETER (npe=4)
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      REAL(KIND=4):: ttarget
      PARAMETER (ttarget=60.0e0)
      REAL(KIND=4):: p(1:257,1:129,-1:33)
      REAL(KIND=4):: b(1:257,1:129,0:32,1:3)
      REAL(KIND=4):: c(1:257,1:129,0:32,1:3)
      REAL(KIND=4):: bnd(1:257,1:129,0:32)
      REAL(KIND=4):: wrk1(1:257,1:129,0:32)
      REAL(KIND=4):: wrk2(1:257,1:129,0:32)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      INTEGER(KIND=4):: loop
      INTEGER(KIND=4):: j
      INTEGER(KIND=4):: i
      REAL(KIND=4):: s0
      REAL(KIND=4):: ss
      INTEGER(KIND=4):: k
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTRINSIC mod
      INTEGER(KIND=4):: spmdX0
      INTEGER(KIND=4):: spmdX1
      INTEGER(KIND=4):: spmd_startX0
      INTEGER(KIND=4):: spmd_endX0
      INTEGER(KIND=4):: spmd_stepX0
      INTEGER(KIND=4):: spmdX2
      INTEGER(KIND=4):: spmdX3
      INTEGER(KIND=4):: spmd_startX1
      INTEGER(KIND=4):: spmd_endX1
      INTEGER(KIND=4):: spmd_stepX1
      INTEGER(KIND=4):: ierrX0
      INTEGER(KIND=4):: ireqX0
      INTEGER(KIND=4):: ireqX1
      INTEGER(KIND=4):: ireqX2
      INTEGER(KIND=4):: ireqX3
      INTEGER(KIND=4):: ierrX1
      INTEGER(KIND=4):: statusX0(1:MPI_STATUS_SIZE)
      INTEGER(KIND=4):: ierrX2
      REAL(KIND=4):: gosaX0
      REAL(KIND=4):: recvbufX0
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /workX1/wrk2
      COMMON /workX0/wrk1
      COMMON /boundX0/bnd
      COMMON /mtrxX2/c
      COMMON /mtrxX1/b
      COMMON /mtrxX0/a
      COMMON /presX0/p
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      DO loop=1,nn,1
        gosa = 0.0e0
        ireqX0 = MPI_REQUEST_NULL
        ireqX1 = MPI_REQUEST_NULL
        ireqX2 = MPI_REQUEST_NULL
        ireqX3 = MPI_REQUEST_NULL
        IF (ORG_RANK.LT.ORG_SIZE-1) THEN
          CALL MPI_Isend(p(1,1,32),33153,MPI_REAL4,ORG_RANK+1,100,MPI_CO&
     &MM_WORLD,ireqX0,ierrX1)
          CALL MPI_Irecv(p(1,1,33),33153,MPI_REAL4,ORG_RANK+1,100,MPI_CO&
     &MM_WORLD,ireqX1,ierrX1)
        ENDIF
        IF (ORG_RANK.GT.0) THEN
          CALL MPI_Irecv(p(1,1,-1),33153,MPI_REAL4,ORG_RANK-1,100,MPI_CO&
     &MM_WORLD,ireqX2,ierrX1)
          CALL MPI_Isend(p(1,1,0),33153,MPI_REAL4,ORG_RANK-1,100,MPI_COM&
     &M_WORLD,ireqX3,ierrX1)
        ENDIF
        CONTINUE
        CALL MPI_Wait(ireqX0,statusX0,ierrX1)
        CALL MPI_Wait(ireqX1,statusX0,ierrX1)
        CALL MPI_Wait(ireqX2,statusX0,ierrX1)
        CALL MPI_Wait(ireqX3,statusX0,ierrX1)
        spmdX0 = mod(ORG_RANK,4)
        spmdX1 = 33*spmdX0
        IF (spmdX0.LE.0) THEN
          spmd_startX0 = 1-spmdX1
        ELSE
          spmd_startX0 = 0
        ENDIF
        IF (spmdX0.LT.(kmax-2)/33) THEN
          spmd_endX0 = 32
        ELSE
          spmd_endX0 = kmax-2-spmdX1
        ENDIF
        spmd_stepX0 = 1
        gosaX0 = gosa
        gosa = 0.0e0
        DO k=spmd_startX0,spmd_endX0,1
          DO j=2,jmax-1,1
            DO i=2,imax-1,1
              s0 = a(i,j,k,1)*p(i+1,j,k)+a(i,j,k,2)*p(i,j+1,k)+a(i,j,k,3&
     &)*p(i,j,k+1)+b(i,j,k,1)*(p(i+1,j+1,k)-p(i+1,j-1,k)-p(i-1,j+1,k)+p(&
     &i-1,j-1,k))+b(i,j,k,2)*(p(i,j+1,k+1)-p(i,j-1,k+1)-p(i,j+1,k-1)+p(i&
     &,j-1,k-1))+b(i,j,k,3)*(p(i+1,j,k+1)-p(i-1,j,k+1)-p(i+1,j,k-1)+p(i-&
     &1,j,k-1))+c(i,j,k,1)*p(i-1,j,k)+c(i,j,k,2)*p(i,j-1,k)+c(i,j,k,3)*p&
     &(i,j,k-1)+wrk1(i,j,k)
              ss = (s0*a(i,j,k,4)-p(i,j,k))*bnd(i,j,k)
              gosa = gosa+ss*ss
              wrk2(i,j,k) = p(i,j,k)+omega*ss
            ENDDO
          ENDDO
        ENDDO
        CALL MPI_Allreduce(gosa,recvbufX0,1,MPI_REAL4,MPI_SUM,MPI_COMM_W&
     &ORLD,ierrX2)
        gosa = gosaX0+recvbufX0
        spmdX2 = mod(ORG_RANK,4)
        spmdX3 = 33*spmdX2
        IF (spmdX2.LE.0) THEN
          spmd_startX1 = 1-spmdX3
        ELSE
          spmd_startX1 = 0
        ENDIF
        IF (spmdX2.LT.(kmax-2)/33) THEN
          spmd_endX1 = 32
        ELSE
          spmd_endX1 = kmax-2-spmdX3
        ENDIF
        spmd_stepX1 = 1
        DO k=spmd_startX1,spmd_endX1,1
          DO j=2,jmax-1,1
            DO i=2,imax-1,1
              p(i,j,k) = wrk2(i,j,k)
            ENDDO
          ENDDO
        ENDDO
      ENDDO
      RETURN
      END SUBROUTINE
      FUNCTION gdtime(time)
      INCLUDE 'mpif.h'
      REAL(KIND=4):: gdtime
      REAL(KIND=4):: time(1:2)
      REAL(KIND=4):: a(1:257,1:129,0:32,1:4)
      INTEGER(KIND=4):: npe
      PARAMETER (npe=4)
      INTEGER(KIND=4):: mimax
      PARAMETER (mimax=257)
      INTEGER(KIND=4):: mjmax
      PARAMETER (mjmax=129)
      INTEGER(KIND=4):: mkmax
      PARAMETER (mkmax=129)
      REAL(KIND=4):: ttarget
      PARAMETER (ttarget=60.0e0)
      REAL(KIND=4):: p(1:257,1:129,-1:33)
      REAL(KIND=4):: b(1:257,1:129,0:32,1:3)
      REAL(KIND=4):: c(1:257,1:129,0:32,1:3)
      REAL(KIND=4):: bnd(1:257,1:129,0:32)
      REAL(KIND=4):: wrk1(1:257,1:129,0:32)
      REAL(KIND=4):: wrk2(1:257,1:129,0:32)
      INTEGER(KIND=4):: imax
      INTEGER(KIND=4):: jmax
      INTEGER(KIND=4):: kmax
      REAL(KIND=4):: omega
      REAL(KIND=4):: ldtime(0:0)
      EXTERNAL dtime
      REAL(KIND=4):: dtime
      REAL(KIND=4):: UTL_tmp001
      INTEGER(KIND=4):: ORG_RANK
      INTEGER(KIND=4):: ORG_SIZE
      INTEGER(KIND=4):: ierrX0
      INTRINSIC mod
      REAL(KIND=4):: ldtimeX0
      INTEGER(KIND=4):: ierrX1
      COMMON /othersX3/omega
      COMMON /othersX2/kmax
      COMMON /othersX1/jmax
      COMMON /othersX0/imax
      COMMON /workX1/wrk2
      COMMON /workX0/wrk1
      COMMON /boundX0/bnd
      COMMON /mtrxX2/c
      COMMON /mtrxX1/b
      COMMON /mtrxX0/a
      COMMON /presX0/p
      COMMON /ORG_COMMON/ORG_RANK,ORG_SIZE
      UTL_tmp001 = dtime(time)
      IF (0.EQ.ORG_RANK) ldtime(mod(0,1)) = UTL_tmp001
      IF (ORG_RANK.EQ.0) ldtimeX0 = ldtime(mod(0,1))
      CALL MPI_Bcast(ldtimeX0,1,MPI_REAL4,0,MPI_COMM_WORLD,ierrX1)
      gdtime = ldtimeX0
      RETURN
      END FUNCTION
